/*
Ai Artillery Framework
By [ZSU]Blake www.zspecialunit.org

Ok this is a sample script for the Ai artillery Framework. It can be used in isolation or incorporated into something more complicated without having to recreate all the important aspects from scratch.
The basic implementation requires at a minimum a target.
eg null = [FO,"Markername"] execVM "callsmokearea.sqf" it requires you have a artillery object synced to an artillery module named Art1 and the smoke round magazine loaded in the artillery object.
Place this in a FO unit and place a marker to determine the centre of the trigger area.

Optional arguments are

Battery - which is the name of the artillery module you are calling (Default Art1)
Number of rounds - How many rounds to fire assuming the artillery has the ammunition (Default 1)
Round Type - Select the type of round HE by default. The other types must be added to the artillery objects for them to fire them (Default "HE")
Dispersion - Basically how much spread between rounds (Default 100)
Prediction Calibrator - A way to influence how far ahead in the current direction of the target to rounds land (Default 20)
Skill - A basic way to see how accurate the placement is values from 1 to 10 (Default 5)
Friendly - Checks to ensure their is not a friendly of this type within 50m of the impact location (Default "SoldierWB")
X part of trigger area - Define of wide the trigger will be that is centred on the Marker (Default 500)
Y part of trigger area - Define of long the trigger will be that is centred on the Marker (Default 500)
Trigger Angle - Defines the triggers orientation on the map. (Default 0)

*/

if (!isserver) exitWith {};
Sleep 4;

_FO = _this select 0;
_Mrk = _this select 1;
_battery = if (count _this > 2) then {_this select 2} else {Art1};
_NoRnds = if (count _this > 3) then {_this select 3} else {1};
_RndType = if (count _this > 4) then {_this select 4} else {"SMOKE"};
_Dispersion = if (count _this > 5) then {_this select 5} else {100};
_adjmult = if (count _this > 6) then {_this select 6} else {20};
_skill = if (count _this > 7) then {_this select 7} else {5};
_friendlycheck = if (count _this > 8) then {_this select 8} else {"SoldierWB"};
_areaX = if (count _this > 9) then {_this select 9} else {500};
_areaY = if (count _this > 10) then {_this select 10} else {500};
_areaAngle = if (count _this > 11) then {_this select 11} else {0};
_Detect = "WEST";


if  (_friendlycheck != "SoldierWB") Then
	{
	_Detect = "EAST";
	
	};

Sleep 2;

While {alive _FO} do {
_Startlook = getmarkerpos _Mrk;
_trg=createTrigger["EmptyDetector",getMarkerPos _Mrk];
_trg setTriggerArea[_areaX,_areaY,_areaAngle,false];
_trg setTriggerActivation[_Detect,"PRESENT",true];
_trg setTriggerStatements["this", "", ""]; 
sleep 1;

if (!isNull (list _trg select 0)) then 
	{
	sleep 1;
	_null1 = [list _trg select 0,_battery,_NoRnds,_RndType,_Dispersion,_adjmult,_skill,"Civilian"] execVM "aifiremission.sqf"; 
	};

Sleep 5;
deleteVehicle _trg;
Sleep 1;
_Mrk setmarkerpos _Startlook;
};
